\section{Polynomial Division}

Let us now present the algorithms for univariate and multivariate polynomial
division. Before we start, let us first introduce leading terms and related
objects which we will use in our further discussion --- for example, in the
definition of Gröbner bases.

\begin{df}
  Let $h = \sum c_\alpha x^\alpha \in \F\!\left[\textbf{x} \right] \ \backslash \ \{0\}$ be a nonzero
  polynomial, $F$ a subset of $\Fg \ \backslash \ \{0\}$ and let $\succeq$ be a monomial order
  on $\Mx$.
  ~\begin{enumerate}[label=(\roman*)]
  \item The \textbf{multidegree} of $h$ is multideg($h$) = max($\alpha \in
    \mathbb{N}_0^n\ |\ c_\alpha \neq 0$). The maximum is taken with respect to $\succeq$.
  \item The \textbf{leading coefficient} of $h$ is LC($h$) =
    $c_{\text{multideg}\left( h \right)} \in \F$.
  \item $\LC{F} = \set*{\LC{f} \mid f \in F}$.
  \item The \textbf{leading monomial} of $h$ is LM($h$) =
    $x^{\text{multideg}\left( h \right)}$.
  \item $\LM{F} = \set*{\LM{f} \mid f \in F}$.
  \item The \textbf{leading term} of $h$ is LT($h$) = LC($h$) $\cdot$ LM($h$).
  \item $\LT{F} = \set*{\LT{f} \mid f \in F}$.
  \end{enumerate}
  Furthermore, $M(f)$ denotes the set of all monomials in $f$ and
  \[
    M(F) = \bigcup\limits_{f \in F} M(f)
  \]
  denotes the set of all monomials contained in all $f \in F$.
\end{df}

\begin{e}
  Let $f = xy^2z^3 + xy^3 \in \F\!\left[x, y, z\right]$ be a polynomial and
  $\succeq$ a lexicographic order. Then
  \begin{enumerate}[label=(\roman*)]
  \item multideg($f$) = $\left(1, 3, 0\right)$,
  \item LC($f$) = 1,
  \item LM($f$) = $xy^3$,
  \item LT($f$) = $xy^3$ and
  \item $M(f) = \{xy^2z^3, xy^3\}$. 
  \end{enumerate}
\end{e}

\subsection*{Univariate Division and Construction of Finite Fields}
\label{subsec:udiv}

Univariate division is more straightforward and provides an
introduction to multivariate division. We will also utilize univariate division
in univariate polynomial rings for construction of finite fields.

\begin{thm}[\textbf{Univariate Division}]\label{thm:unidiv}
  Let $g\!\left( x \right) \in \F\!\left[ x \right]$ be a univariate polynomial.
  Then every $f\!\left( x \right)$ in $\F\!\left[ x \right]$ can be written as
  $f\!\left( x \right) = q\!\left( x \right)g\!\left( x \right) + r\!\left( x
  \right)$, where $q\!\left( x \right), r\!\left( x \right) \in \F\!\left[ x
  \right]$ are unique and either $r\!\left( x \right) = 0$ or deg$\left(
    r\!\left( x \right)\right) <$ deg$\left( g\!\left( x \right) \right)$.
\end{thm}

\begin{p}
  We can use Algorithm \ref{alg:unidiv} for finding the polynomials $q$ and $r$.
  The proof of correctness and termination can be found in \cite[p. 39]{iva}.
\end{p}

\begin{algorithm}
  \caption{Univariate polynomial division}\label{alg:unidiv}

  \begin{tabular}{ l l}
    \textbf{Input:}  & univariate polynomials $\bm{g, f}$, \\
    \textbf{Output:} & univariate polynomials $\bm{q, r}$ \\
  \end{tabular}
  \\
  \begin{algorithmic}[1]
    \Function{univariate\_division}{$g, f$}
    \State $q \gets 0$
    \State $r \gets f$

    \While{$r \neq 0$ \& LT($g$) divides LT($r$)}
    \State $q \gets q~+$ LT($r$) / LT($g$)
    \State $r \gets r~-$ (LT($r$) / LT($g$))$g$
    \EndWhile

    \State \Return $q, r$
    \EndFunction
  \end{algorithmic}
\end{algorithm}

\begin{e}\label{e:quotient}
  Let $f\!\left( x \right) \in \F\!\left[x \right]$ be a univariate polynomial of
  degree $d$ = deg($f\!\left( x \right)$) and $\langle f\!\left( x \right)
  \rangle$ the ideal generated by $f\!\left( x \right)$. The elements of the
  quotient ring $\F\!\left[ x \right] / \langle f\!\left( x \right) \rangle$ can
  be written as univariate polynomials \[c_{d-1} x^{d-1} + \ldots + c_1 x + c_0 \]
  in $\F\!\left[ x \right]$ of degree less than $d$. In this quotient ring, we
  can use addition from Definition \ref{df:poly_op} (i). However, we define
  multiplication by applying Theorem \ref{thm:unidiv} in the following way. Let
  us have two univariate polynomials $g\!\left( x \right), h\!\left( x \right)
  \in \F\!\left( x \right)$. There must exist another two univariate polynomials
  $q\!\left( x \right), r\!\left( x \right) \in \F\!\left( x \right)$ such that
  $g\!\left( x \right) h\!\left( x \right) = q\!\left( x \right) f\!\left( x
  \right) + r\!\left( x \right)$, where deg($r\!\left( x \right)$) $<$
  deg($f\!\left( x \right)$) = $d$. We now take $r\!\left( x \right)$ as the
  product of $g\!\left( x \right)$ and $h\!\left( x \right)$.
\end{e}

\begin{pr}
  \label{pr:quotient}
  Let $\F$ be a finite field of order $q = p^n$ and $f\!\left( x \right) \in
  \F\!\left[x \right]$ a univariate polynomial of degree $d$. The quotient ring
  $\F\!\left[ x \right] / \langle f\!\left( x \right) \rangle$, as constructed in Example
  \ref{e:quotient}, is a finite field of order $q^d = p^{nd}$ if and only if
  $f\!\left( x \right)$ is irreducible over $\F\!\left[ x \right]$.
\end{pr}

\begin{p}
  The proof requires introducing further concepts and can be found in
  \cite[Chapter 1.3]{lidl}. Let us provide an intuitive insight though. We can
  think of irreducible polynomials as a generalization of primes. Recall Example
  \ref{e:ff} (iii), where the primality of the modulus ensured that each
  non-zero element had its multiplicative inverse. The situation is similar in
  this case as well and we can find the inverses by leveraging the extended
  Euclidean algorithm for univariate polynomials, see e.g. \cite[p. 81]{menezes}.
\end{p}

\begin{pr}
  \label{pr:extension_field}
  Let $f \in \Fg$ be irreducible over the field $\F$. Then there exists an
  extension of $\F$ with a root of $f$.
\end{pr}

\begin{p}
  Consider the finite field $\E = \Fg / \langle f \rangle$. The elements of $\E$
  are the cosets $[r] = r + \langle f \rangle$ with $r \in \Fg$. For any $a \in
  \F$, we can obtain a coset $[a]$ determined by the constant polynomial $a$.
  The mapping $a \mapsto [a]$ gives an isomorphism from $\F$ onto a subfield
  $\F'$ of $\E$, so that $\F'$ may be identified with $\F$. Particularly, $\E$
  can be seen as an extension of $\F$. Now, for every $r(x) = a_0 + a_1 x + \cdots
  + a_m x^m \in \Fg$ we have $[r] = [a_0 + a_1 x + \cdots + a_m x^m] = [a_0] + [a_1][x]
  + \cdots + [a_m][x]^m = a_0 + a_1 [x] + \cdots + a_m [x]^m$ by the rules for
  operating with cosets and the identification $[a_i] = a_i$. Hence, we can write
  every element of $\E$ as a polynomial expression in $[x]$ with coefficients in
  $\F$. We say that the extension field $\E$ is obtained by \textbf{adjoining}
  $[x]$ and we denote this field by $\F([x])$. Note that if $f(x) = b_0 + b_1 x +
  \cdots + b_n x^n$, then $f([x]) = b_0 + b_1[x] + \cdots + b_n[x]^n = [b_0 + b_1 x +
  \cdots + b_n x^n] = [f] = [0]$, so that [$x$] is a root of $f$.
\end{p}
\subsection*{Multivariate Division}
\label{subsec:muldiv}

We will use the following theorem in the description of algorithms for computing
Gröbner bases.

\begin{thm}[\textbf{Multivariate Division}]\label{thm:muldiv}
  Let $\succeq$ be a monomial order on $\Mx$ and let $F = \sn[m]{f}$ be an
  ordered $m$-tuple of polynomials in $\Fg$. Then every $f \in \Fg$ can be
  written as $f = q_1 f_1 + \cdots + q_m f_m + r$, where $q_i, r \in \Fg$, and
  either $r = 0$ or $r$ is a linear combination, with coefficients in $\F$, of
  monomials, none of which is divisible by any of $\mathrm{LT}(f_1), \ldots,
  \mathrm{LT}(f_m)$. We call $r$ a \textbf{remainder} of $f$ on division by $F$.
  Furthermore, if $q_i f_i \neq 0$, then $\LM{f} \succeq \LM{q_i f_i}$.
\end{thm}

\begin{p}
  We can use Algorithm \ref{alg:muldiv} for finding the polynomials $q_i$ and
  $r$. The proof of correctness and termination can be found in \cite[p.
  64]{iva}.
\end{p}

\begin{algorithm}
  \caption{Multivariate polynomial division}\label{alg:muldiv}

  \begin{tabular}{l l}
    \textbf{Input:}  & polynomials $\bm{f_1, \ldots, f_m, f}$, \\
    \textbf{Output:} & polynomials $\bm{q_1, \ldots, q_m, r}$ \\
  \end{tabular}
  \\
  \begin{algorithmic}[1]
    \Function{multivariate\_division}{$\s[m]{f}, f$}
    \State $q_i \gets 0$
    \State $r \gets 0$
    \State $p \gets f$

    \While{$p \neq 0$}
    \State $i \gets 1$
    \State $\mathit{divisionoccured} \gets \mathit{False}$

    \While{$i \le m$ \& $\mathit{divisionoccured} = \mathit{False}$}
    \If{LT($f_i$) $\mid$ LT($p$)}
    \State $q_i \gets q_i + \mathrm{LT}(p) / \mathrm{LT}(f_i)$
    \State $p \gets p - (\mathrm{LT}(p) / \mathrm{LT}(f_i)) f_i$
    \State $\mathit{divisionoccured} \gets \mathit{True}$ 
    \Else
    \State $i \gets i + 1$
    \EndIf
    \EndWhile
    \If{$\mathit{divisionoccured} = \mathit{False}$}
    \State $r \gets r + \mathrm{LT}(p)$
    \State $p \gets p - \mathit{LT}(p)$
    \EndIf
    \EndWhile

    \State \Return $\s[m]{q}, r$
    \EndFunction
  \end{algorithmic}
\end{algorithm}

We will denote by $\overline{f}^F$ the remainder on division of $f$ by the
ordered m-tuple $F = \sn[m]{f}$.
